#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NR 50
#define NC 50


void stampa_matrice(float [][NC], int , int );
void leggi_matrice(float [][NC], int , int );
void stampa_vettore(float [], int);
float prod_scalare_vettori(float [], float [], int);
float modulo(float [], int );
int angolo_vettori(float *, float [], float [], int );


int main ()
{

   int i,scelta,ok,n_righe,n_colonne,vett1,vett2;
   float mat[NR][NC],angolo;


   //acquisizione del numero di righe
   printf("Quante righe vuoi immettere?  ");
   scanf("%d",&n_righe);

   //acquisizione del numero di colonne
   printf("Quante righe vuoi immettere?  ");
   scanf("%d",&n_colonne);

   leggi_matrice(mat,n_righe,n_colonne);


   ok=1;
   while(ok){
	 system("cls\n");
     printf("MENU\n");
     printf("1) Stampa di un vettore riga a scelta\n");
     printf("2) Stampa dei vettori riga\n");
     printf("3) Stampa del prodotto scalare di due vettori riga\n");
     printf("4) Stampa del modulo di un vettore a scelta\n");
     printf("5) Stampa dell'angolo fra due vettori a scelta\n");
     printf("6) esci\n");
     scanf("%d",&scelta);

	 switch(scelta){
		 case 1:
	            system("cls\n");

				do{
					printf("Dammi un vettore:  ");
					scanf("%d",&vett1);
				}while(vett1<0||vett1>=n_righe);

				stampa_vettore(mat[vett1],n_righe);

				getchar();
				getchar();
			    break;
		 case 2:
	            system("cls\n");

				for(i=0;i<n_righe;i++)
				  stampa_vettore(mat[i],n_righe);

				getchar();
				getchar();
			    break;
		 case 3:
	            system("cls\n");

				do{
					printf("Dammi il primo vettore:  ");
					scanf("%d",&vett1);
				}while(vett1<0||vett1>=n_righe);

				do{
					printf("Dammi il secondo vettore:  ");
					scanf("%d",&vett2);
				}while(vett2<0||vett2>=n_righe);

                printf("Il prodotto scalare  e: %f\n",prod_scalare_vettori(mat[vett1],mat[vett2],n_righe));

				getchar();
				getchar();
			    break;
		 case 4:
	            system("cls\n");


				do{
					printf("Dammi un vettore:  ");
					scanf("%d",&vett1);
				}while(vett1<0||vett1>=n_righe);

                printf("Il modulo del  vettore e: %f\n",modulo(mat[vett1],n_righe));

				getchar();
				getchar();
			    break;
		 case 5:
	            system("cls\n");

				do{
					printf("Dammi il primo vettore:  ");
					scanf("%d",&vett1);
				}while(vett1<0||vett1>=n_righe);

				do{
					printf("Dammi il secondo vettore:  ");
					scanf("%d",&vett2);
				}while(vett2<0||vett2>=n_righe);

                if(angolo_vettori(&angolo,mat[vett1],mat[vett2],n_righe))
					printf("L'angolo e: %f\n",angolo);
				else
					printf("Calcolo non possibile (uno dei due vettori ha modulo nullo)\n");

				getchar();
				getchar();
			    break;
		 case 6:
			    ok=0;
			    break;
	 }
	 system("cls\n");
   }

   printf("Fine delle operazioni\n");

}



int angolo_vettori(float *angolo, float vett1[], float vett2[], int n)
// calcola l'angolo fra due vettori
{
   int i;
   float mod1,mod2;

   mod1=modulo(vett1,n);
   if(mod1==0)
	   return 0;

   mod2=modulo(vett2,n);
   if(mod2==0)
	   return 0;

   //calcolo dell'angolo in radianti
   *angolo=acos(prod_scalare_vettori(vett1,vett2,n)/(mod1*mod2));

   //calcolo dell'angolo in gradi
   *angolo=(*angolo)*180.0/3.14159265;

   return 1;
}


float modulo(float vett1[], int n)
// modulo di vett1
{
   float prod=0;

   return sqrt(prod_scalare_vettori(vett1,vett1,n));
}


float prod_scalare_vettori(float vett1[], float vett2[], int n)
// prodotto scalare fra vett1 e vett2
{
   int i;
   float prod=0;

   for(i=0;i<n;i++)
      prod+=vett1[i]*vett2[i];

  return prod;
}


void stampa_vettore(float mat[], int n)
// stampa un vettore
{

   int i;

   for(i=0;i<n;i++)
       printf("%f\t",mat[i]);
     printf("\n");
}


void stampa_matrice(float mat[][NC], int n, int m)
// stampa la matrice
{

   int i,j;

   for(i=0;i<n;i++){
     for(j=0;j<m;j++)
       printf("%f\t",mat[i][j]);
     printf("\n");
   }
}



void leggi_matrice(float mat[][NC], int n, int m)
// legge la matrice
{

   int i,j;

   for(i=0;i<n;i++){
     printf("Dammi la riga n. %d :  ",i);
     for(j=0;j<m;j++)
       scanf("%f",&mat[i][j]);
   }
}


