#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define DIM1 20
#define DIM2 20


void leggi_matrice(float [][DIM2], int, int);
void stampa_matrice(float [][DIM2], int, int);
float determinante(float [][DIM2],int , int );
void calcola_minore(float [][DIM2],int ,float [][DIM2],int , int );


int main ()
//calcolo del determinante con il metodo di Laplace - usata la ricorsione
{

	int i,j,riga,colonna,scambio,dimr,dimc,numero_cambi,trovato,rango;
	float det;
	float mat1[DIM1][DIM2],mat2[DIM1][DIM2];


	printf("Dammi il numero di righe e colonne della matrice A:  ");
	scanf("%d",&dimr);
	scanf("%d",&dimc);

	leggi_matrice(mat1,dimr,dimc);


	printf("Matrice di partenza:\n");
	stampa_matrice(mat1,dimr,dimc);


	det=determinante(mat1,dimr,dimc);
	printf("\n\nDeterminante: %f\n",det);

}



void leggi_matrice(float a[][DIM2], int dimr, int dimc)
{

   int i,j;

	//lettura della matrice
	printf("Lettura matrice:\n");
	for(i=0;i<dimr;i++){
		printf("Riga numero %d:  ",i);
	    for(j=0;j<dimc;j++)
			scanf("%f",&a[i][j]);
	}

}

void stampa_matrice(float a[][DIM2], int dimr, int dimc)
{

   int i,j;

	//stampa della matrice
	for(i=0;i<dimr;i++){
	    for(j=0;j<dimc;j++)
			printf("%f\t",a[i][j]);
		printf("\n");
	}

}

float determinante(float mat[DIM1][DIM2],int dimr, int dimc)
{
	int i;
	float det,minore[DIM1][DIM2];

	if(dimr!=dimc){
	  printf("dimr: %d\tdimc: %d\n",dimr,dimc);
	  exit(0);
	}

	if(dimr<2){
	  printf("matrice troppo piccola dimr: %d\tdimc: %d\n",dimr,dimc);
	  exit(0);
	}

    if(dimr==2)
		return mat[0][0]*mat[1][1]-mat[1][0]*mat[0][1];
	else{
		det=0;
	    for(i=0;i<dimr;i++){
		    calcola_minore(mat,dimr,minore,i,0);
			det+=pow(-1,i)*mat[i][0]*determinante(minore,dimr-1,dimc-1);
        }
	}//if dimr

	return det;
}


void calcola_minore(float mat[DIM1][DIM2],int dim,float minore[DIM1][DIM2],int riga, int colonna)
{

  int i,j,i_m,j_m;

  i_m=0;
  for(i=0;i<dim;i++){
    //copio ogni riga, tralasciando la riga da togliere
	if(i!=riga){
      //copio la riga, tralasciando la colonna da togliere
	  j_m=0;
	  for(j=0;j<dim;j++)
		if(j!=colonna){
			minore[i_m][j_m]=mat[i][j];
	        j_m++;   //incremento il contatore colonne del minore
		}
	  i_m++;  //incremento il contatore righe del minore
    }//if riga
  }//for i

  /*
  printf("MINORE:\n");
  stampa_matrice(minore,dim-1,dim-1);
  printf("\n\n");
  */

}



