#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N 500


void leggi_vettore (float [], int );
void stampa_vettore (float [], int );
void somma_vettori(float [], float [],float [], int );
float prod_scalare_vettori(float [], float [], int);
float modulo(float [], int );
int angolo_vettori(float *, float [], float [], int );


int main ()
{

   int i,scelta,ok,n_elementi;
   float vett1[N],vett2[N],vett3[N],angolo;


   //acquisizione del vettore
   printf("Quanti valori vuoi immettere?  ");
   scanf("%d",&n_elementi);


   leggi_vettore(vett1,n_elementi);
   leggi_vettore(vett2,n_elementi);



   ok=1;
   while(ok){
	 system("cls\n");
     printf("MENU\n");
     printf("1) Stampa dei vettori\n");
     printf("2) Stampa del vettore somma\n");
     printf("3) Stampa del prodotto scalare dei vettori\n");
     printf("4) Stampa del modulo dei vettori\n");
     printf("5) Stampa dell'angolo fra i due vettori\n");
     printf("6) esci\n");
     scanf("%d",&scelta);

	 switch(scelta){
		 case 1:
	            system("cls\n");
				stampa_vettore(vett1,n_elementi);
				stampa_vettore(vett2,n_elementi);

				getchar();
				getchar();
			    break;
		 case 2:
	            system("cls\n");

                somma_vettori(vett1,vett2,vett3,n_elementi);

				printf("Il vettore somma e: \n");
				stampa_vettore(vett3,n_elementi);

				getchar();
				getchar();
			    break;
		 case 3:
	            system("cls\n");

                printf("Il prodotto scalare  e: %f\n",prod_scalare_vettori(vett1,vett2,n_elementi));

				getchar();
				getchar();
			    break;
		 case 4:
	            system("cls\n");

                printf("Il modulo del primo vettore e: %f\n",modulo(vett1,n_elementi));
                printf("Il modulo del secondo vettore e: %f\n",modulo(vett2,n_elementi));

				getchar();
				getchar();
			    break;
		 case 5:
	            system("cls\n");

                if(angolo_vettori(&angolo,vett1,vett2,n_elementi))
					printf("L'angolo e: %f\n",angolo);
				else
					printf("Calcolo non possibile (uno dei due vettori ha modulo nullo)\n");

				getchar();
				getchar();
			    break;
		 case 6:
			    ok=0;
			    break;
	 }
	 system("cls\n");
   }

   printf("Fine delle operazioni\n");

}



int angolo_vettori(float *angolo, float vett1[], float vett2[], int n)
{
   int i;
   float mod1,mod2;

   mod1=modulo(vett1,n);
   if(mod1==0)
	   return 0;

   mod2=modulo(vett2,n);
   if(mod2==0)
	   return 0;

   //calcolo dell'angolo in radianti
   *angolo=acos(prod_scalare_vettori(vett1,vett2,n)/(mod1*mod2));

   //calcolo dell'angolo in gradi
   *angolo=(*angolo)*180.0/3.14159265;

   return 1;
}


float modulo(float vett1[], int n)
// modulo di vett1
{
   float prod=0;

   return sqrt(prod_scalare_vettori(vett1,vett1,n));
}


float prod_scalare_vettori(float vett1[], float vett2[], int n)
// prodotto scalare fra vett1 e vett2
{
   int i;
   float prod=0;

   for(i=0;i<n;i++)
      prod+=vett1[i]*vett2[i];

  return prod;
}


void somma_vettori(float vett1[], float vett2[],float somma[], int n)
// mette in vett3 la somma vett1+vett2
{

   int i;

   for(i=0;i<n;i++)
      somma[i]=vett1[i]+vett2[i];
}


void stampa_vettore (float vett1[], int n)
//stampa il vettore
{
   int i;

   for(i=0;i<n;i++)
     printf("%f\t",vett1[i]);
   printf("\n");

}


void leggi_vettore (float vett1[], int n)
// legge il vettore
{

   int i;

   printf("Dammi il vettore:  ");
   for(i=0;i<n;i++)
     scanf("%f",&vett1[i]);
}


