#include <stdio.h>
#include <math.h>

float calcolo_integrale(float , float , long int, int );
float funzione_integranda(float );


int main ()
//calcolo integrale con formula del trapezio oppure di Cavalieri-Simpson
{

   int metodo;
   long int npassi,ncifre,controllo;
   float a,b,somma,somma2,per_cifre,ftmp;

	printf("Dammi estremo A: ");
	scanf("%f",&a);

	printf("Dammi estremo B: ");
	scanf("%f",&b);

	printf("Dammi numero di passi iniziali: ");
	scanf("%d",&npassi);

	printf("Dammi numero di cifre corrette: ");
	scanf("%d",&ncifre);


    do{
	   printf("Metodo di integrazione: (1) trapezio oppure (2) Cavalieri-Simpson   ");
	   scanf("%d",&metodo);
    }while( !((metodo==1)||(metodo==2)));

	per_cifre=pow(10,ncifre);
	printf("per_cifre: %f\n",per_cifre);

	somma2=calcolo_integrale(a,b,npassi,metodo);

	printf("Prima stima: %f\n",somma2);

	controllo=1;
	while(controllo){

      somma=somma2;

	  npassi*=2;

	  somma2=calcolo_integrale(a,b,npassi,metodo);

	  printf("Numero passi\t %d\t",npassi);
	  printf("Valore: %f\n",somma2);

	  ftmp=((somma-somma2)/somma)*per_cifre;
	  if(ftmp<0)
		  ftmp=-ftmp;
	  controllo=ftmp>1.0;
	}//while


}


float funzione_integranda(float x)
//funzione da integrare
{

  return x*x;

}

float calcolo_integrale(float estremoA, float estremoB, long int npassi, int metodo)
//ritorna "-1" in caso di metodo sconosciuto
{
	long int passo;
	float h,somma,ftmp;

	h=(estremoB-estremoA)/npassi;

	somma=0;

	switch(metodo){
		case 1:
	           for(passo=1;passo<npassi;passo++)
                   somma+=funzione_integranda(estremoA+passo*h);

	            somma+=(funzione_integranda(estremoA)+funzione_integranda(estremoB))/2.;
	            somma*=h;
			   break;
		case 2:
	           //somma sui termini dispari
	           for(passo=1;passo<npassi;passo+=2)
                  somma+=funzione_integranda(estremoA+passo*h);
               somma*=4;

	           ftmp=0;
	           //somma sui termini pari
	           for(passo=2;passo<npassi;passo+=2)
                  ftmp+=funzione_integranda(estremoA+passo*h);
               ftmp*=2;

	           somma+=ftmp;

	           somma+=funzione_integranda(estremoA)+funzione_integranda(estremoB);
	           somma*=h/3.;
			   break;
		default:
		       printf("Metodo sconosciuto\n");
		       return -1;
	}//switch

	return somma;

}


